cordova.define("com.adobe.plugins.GAPlugin.GAPlugin", function(require, exports, module) { var exec = require('cordova/exec');

var analytics = {
    
    // Should ONLY be called ONCE and only for default tracker
    // initialize google analytics with an account ID and the min number of seconds between posting
    // this will be set as the default tracker!
    // trackUncaughtExceptions will be set to YES
    //
    // id = the GA account ID of the form 'UA-00000000-0'
    // period = the minimum interval for transmitting tracking events if any exist in the queue
    // enableDebug = bool for enable debug (true = debug, false = not debug)
    init: function(success, fail, id, period, enableDebug) {
        return exec(success, fail, 'GAPlugin', 'initGA', [id, period, enableDebug]);
    },
    
    // log an event
    //
    // id = the GA account ID of the form 'UA-00000000-0'
    // category = The event category. This parameter is required to be non-empty.
    // eventAction = The event action. This parameter is required to be non-empty.
    // eventLabel = The event label. This parameter may be a blank string to indicate no label.
    // eventValue = The event value. This parameter may be -1 to indicate no value.
    trackEvent: function(success, fail, id, category, eventAction, eventLabel, eventValue) {
        return exec(success, fail, 'GAPlugin', 'trackEvent', [id, category, eventAction, eventLabel, eventValue]);
    },
    
    // log a page view
    //
    // id = the GA account ID of the form 'UA-00000000-0'
    // pageURL = the URL of the page view
    trackPage:function(success, fail, id, pageURL) {
        return exec(success, fail, 'GAPlugin', 'trackPage', [id, pageURL]);
    },
    
    // Set a custom variable. The variable set is included with
    // the next event only. If there is an existing custom variable at the specified
    // index, it will be overwritten by this one.
    //
    // id = the GA account ID of the form 'UA-00000000-0'
    // value = the value of the variable you are logging
    // index = the numerical index of the dimension to which this variable will be assigned (1 - 20)
    //  Standard accounts support up to 20 custom dimensions.
    setVariable: function(success, fail, id, index, value) {
        return exec(success, fail, 'GAPlugin', 'setVariable', [id, index, value]);
    }
    
};

module.exports = analytics;



});
