(function() {

	overrideWindowOnErrorHandler();

	function overrideWindowOnErrorHandler() {

		window.onerror = windowOnErrorHandler;

	}

	function windowOnErrorHandler(desc, page, line) {

		Iea.Util.windowOnErrorHandler(desc, page, line);

	}

	// Check url for a cid and setup app if the parameter exits

	setIeAppCidFromUrl();

	// Check url for other parameters

	IeAppConfig.urlTpromoCode = getUrlParameter('promo');

	// Inject google analytics

	if (IeAppConfig.isWebApp()) {

		// redirectIfNotWebkit();
		injectGoogleAnalytics();

	}

	// Inject a custom stylesheet

	injectCustomStyle();

	function setIeAppCidFromUrl() {

		// The cid is set by the server version of app.html in a script.
		// Try getting that value first.
		var cid;

		// If cid not set by server (i.e. if testing in Sencha Architect) try getting from url.
		if (typeof IE_APP_SERVER_CID != 'undefined') {
			cid = IE_APP_SERVER_CID;
		} else {
			cid = getUrlParameter('cid');
		}

		if (cid) {
			IeAppConfig.cid = cid;
		} else {
			// Just use default
		}

	}

	function getUrlParameter(name) {

		name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
		var regexS = "[\\?&]" + name + "=([^&#]*)";
		var regex = new RegExp(regexS, "i"); // "i" makes case-insensitive matching
		var results = regex.exec(window.location.href);
		if (results === null)
			return "";
		else
			return results[1];

	}

	function injectCustomStyle() {

		var cid = IeAppConfig.cid;
		var width = '';
		var height = '';

		try {

			width = (window.innerWidth > 0) ? window.innerWidth : screen.width;
			height = (window.innerHeight > 0) ? window.innerHeight : screen.height;

		} catch (e) {
		}

		// Default cacheKey to milliseconds since the epoch.

		var cacheKey = new Date().getTime();

		// Cache key can be sent by server version of app.html. Use that so that we can hopefully take
		// advantage of cached version if the css hasn't been updated recently.

		if (typeof IE_APP_CSS_CACHE_KEY != 'undefined') {
			cacheKey = IE_APP_CSS_CACHE_KEY;
		}
		
		var scheme = IeAppConfig.allowSsl ? 'https://' : 'http://';

		var ie = document.createElement('link');
		ie.rel = 'stylesheet';
		ie.type = 'text/css';
		ie.href = [
				scheme,
				IeAppConfig.servicesHost,
				'/Util/Style/Css2/',
				cid,
				'/',
				cacheKey,
				'/style.css?width=',
				width,
				'&height=',
				height
		].join('');
		var s = document.getElementsByTagName('head')[0];
		s.appendChild(ie);

	}

	function injectGoogleAnalytics() {

		var ga = document.createElement('script');
		ga.type = 'text/javascript';
		ga.async = true;
		ga.src = ('https:' == document.location.protocol ? 'https://ssl' : 'http://www') + '.google-analytics.com/ga.js';
		var s = document.getElementsByTagName('script')[0];
		s.parentNode.insertBefore(ga, s);

		// Ensure that this global variable is available for use.
		if (typeof _gaq === 'undefined') {
			_gaq = [];
		}

	}

	function redirectIfNotWebkit() {

		// regex test for webkit
		var isWebKit = /webkit/i.test(navigator.userAgent);

		if (!isWebKit) {
			window.location = '/Utilities/NoMobileSupport/' + IeAppConfig.cid;
		}

	}

})();
